;
; Ullrich von Bassewitz, 2002-12-03
;
; unsigned char __fastcall__ get_tv (void);
; /* Return the video mode the machine is using */
;

        .export         _get_tv
		.constructor	detectpalntsc,32  ; other stuff may depend on this!

        .include        "c64/c64.inc"


;--------------------------------------------------------------------------
; _get_tv

.proc   _get_tv

        lda     PALFLAG
        ldx     #0
        rts

.endproc

detectpalntsc:

 ;----------------------------------------------------------------------
 ; Reliable PAL/NTSC-Detector by Ninja/The Dreams/TempesT
 ; for Go64!/CW issue 06/2000 (detailed description there)
 ; This routine can't be fooled like $02a6 and works also with a SCPU
 ;
 ; originally written in AS by Alfred Arnold's
 ;----------------------------------------------------------------------

              sei                         ; disable interrupts
              ldx NMIVec
              ldy NMIVec+1                ; remember old NMI-vector
              lda #<(rt)
              sta NMIVec
              lda #>(rt)                  ; let NMI-vector point to
              sta NMIVec+1                ; a RTI
wait:
              lda VIC_HLINE
              bne wait                    ; wait for rasterline 0 or 256
              lda #$37
              sta VIC_HLINE
              lda #$9b                    ; write testline $137 to the
              sta VIC_CTRL1                   ; latch-register
              lda #$01
              sta VIC_IRR                   ; clear IMR-Bit 0
wait1:
              lda VIC_CTRL1                   ; Is rasterbeam in the area
              bpl wait1                   ; 0-255? if yes, wait
wait2:
              lda VIC_CTRL1                   ; Is rasterbeam in the area
              bmi wait2                   ; 256 to end? if yes, wait
              lda VIC_IRR                   ; read IMR
              and #$01                    ; mask Bit 0
              sta VIC_IRR                   ; clear IMR-Bit 0
              stx NMIVec
              sty NMIVec+1                ; restore old NMI-vector
              cli                         ; enable interrupts
		      sta PALFLAG                 ; update system flag
              rts                         ; return

rt:           rti                         ; go immediately back after
                                          ; a NMI
