/******************************************************
 * Linker script for arm-elf-ld v0.1 (w) Groepaz/Hitmen
 * Target CPU: Arm/T7  Machine: Sega Dreamcast
 ******************************************************/

MEMORY {
    workram   : ORIGIN = 0x00000000, LENGTH = 0x0000fffc   /* ~64k */
    stacktop  : ORIGIN = 0x0000fffc, LENGTH = 4            
    sampleram : ORIGIN = 0x00010000, LENGTH = 0x001f0000   /* ~2M */
}

SECTIONS { 
  .text : { 
    	*(.text)                           /* code */
    	_etext = ABSOLUTE(.) ;
    } > workram
  .data : { 
    	*(.rodata) *(.data) *(COMMON)      /* initialized data */
   	. = ALIGN(4);
    	__ctors = ABSOLUTE(.) ;
   	*(.ctors)                          /* c++ constructors */
   	__ctors_end = ABSOLUTE(.) ;
   	. = ALIGN(4);
    	__dtors = ABSOLUTE(.) ;
   	*(.dtors)                          /* c++ destructors */
   	__dtors_end = ABSOLUTE(.) ;
   	. = ALIGN(4);
	*(.glue_7t);                       /* ? */
   	. = ALIGN(4);
	*(.glue_7);                        /* ? */
    	_edata = ABSOLUTE(.) ;
    } > workram
  .bss (NOLOAD) : { 
    	*(.bss)                            /* non-initialized data */
    	_end = ABSOLUTE(.) ;
    } > workram
                                           /* the heap will be here */
  .stack (NOLOAD) : { 
    	*(.stack)                          /* cpu-stack */
    	_stack = ABSOLUTE(.) ;
    } > stacktop
} 