
#include "gb/gb.h"

#ifndef SCREENX
#define SCREENX (160/8)
#endif

#ifndef SCREENY
#define SCREENY (144/8)
#endif

//#include "font.c"

extern unsigned char font_conio[];

font_t conio_font;
#ifndef revers
unsigned char rvs_flag;
#endif

void conio_init(void)
{

    /* First, init the font system */
    font_init();

    /* Load this one with dk grey background and white foreground */
    //color(WHITE, BLACK, SOLID);
    color( BLACK, WHITE,SOLID);

    /* Load all the fonts that we can */
    conio_font = font_load(font_conio);  /* 96 tiles */

    /* Turn scrolling off (why not?) */
//    mode(get_mode() | M_NO_SCROLL);

}

#if 0
void clrscr(void)
{
unsigned char x,y;

	for(y=0;y<SCREENY;y++)
	{
		for(x=0;x<SCREENX;x++)
		{
			gotoxy(x,y);
			setchar(' ');
		}
	}
}
#endif

#if 0
unsigned char wherex(void)
{
	return(posx());
}
unsigned char wherey(void)
{
	return(posy());
}
#endif

void cputc(const char c)
{
unsigned char x;
	switch(c)
	{
		case '\n':
				gotoxy(wherex(),wherey()+1);
			break;
		case '\r':
				gotoxy(0,wherey());
			break;
		default:
			setchar(c|rvs_flag);
			if((x=wherex()+1)==SCREENX)
			{
				gotoxy(0,wherey()+1);
			}
			else
			{
				gotoxy(x,wherey());
			}
			break;
	}
}

void cclear(char c)
{
	while(c--) cputc(' ');
}
void cclearxy(unsigned char x,unsigned char y,char c)
{
	gotoxy(x,y);
	while(c--) cputc(' ');
}

void chline(char c)
{
	while(c--) cputc('-');
}
void chlinexy(unsigned char x,unsigned char y,char c)
{
	gotoxy(x,y);
	while(c--) cputc('-');
}
void cvline(char c)
{
	while(c--)
	{
		setchar('!');
		gotoxy(wherex(),wherey()+1);
	}
}
void cvlinexy(unsigned char x,unsigned char y,char c)
{
	gotoxy(x,y);
	while(c--)
	{
		setchar('!');
		gotoxy(wherex(),wherey()+1);
	}
}

void cputcxy(unsigned char x,unsigned char y,char c)
{
	gotoxy(x,y);
	cputc(c);
}

unsigned char cpeekchar(void)
{
	static unsigned char c;
	get_bkg_tiles(wherex(),wherey(),1,1,&c);
	return(c);
}
unsigned char cpeekcharxy(unsigned char x,unsigned char y)
{
	static unsigned char c;
	get_bkg_tiles(x,y,1,1,&c);
	return(c);
}
unsigned char cpeekcol(void)
{
	return(0);
}
unsigned char cpeekcolxy(unsigned char x,unsigned char y)
{
	x=x;
	y=y;
	return(0);
}

void cputs(char *s)
{
	while(*s) cputc(*s++);
}
void cputsxy(unsigned char x,unsigned char y,char *s)
{
	gotoxy(x,y);
	while(*s) cputc(*s++);
}

#if 1
#include <stdarg.h>
void cprintf(char *format,...)
{
va_list args;
char string[0x100];
        va_start(args,format);
        vsprintf((char*)string,(char*)format,(va_list)args);
        va_end(args);
		cputs(string);
}
#endif

unsigned char cursor(unsigned char col)
{
	col=col;
	return(0);
}

#ifndef revers
unsigned char revers(unsigned char col)
{
	unsigned char old;
	old=rvs_flag;

	if(col) rvs_flag=0x80;
	else rvs_flag=0;

	if(old) return(1);
	return(0);
}
#endif
#ifndef textcolor
unsigned char textcolor(unsigned char col)
{
	col=col;
	return(1);
}
#endif
#ifndef bgcolor
unsigned char bgcolor(unsigned char col)
{
	col=col;
	return(0);
}
#endif
#ifndef bordercolor
unsigned char bordercolor(unsigned char col)
{
	col=col;
	return(0);
}
#endif


void screensize(unsigned char *x,unsigned char *y)
{
	*x=SCREENX;*y=SCREENY;
}

#if 0
#ifndef cgetc
unsigned char cgetc(void)
{
	return(0);
}
#endif
#ifndef kbhit
unsigned char kbhit(void)
{
	return(0);
}
#endif
#endif

