
#ifndef __CONIO_H__
#define __CONIO_H__

#include "gb.h"

/* conio */

#define CH_CURS_UP		0x01
#define CH_CURS_DOWN	0x02
#define CH_CURS_LEFT	0x03
#define CH_CURS_RIGHT	0x04

#define CH_F1         0x05
#define CH_F3         0x06
#define CH_F5         0x07
#define CH_F7         0x08

#define CH_ESC		8
#define CH_STOP		7 
#define CH_DEL		20

#define CH_RTEE      '+'
#define CH_LTEE      '+'
#define CH_CROSS     '+'
#define CH_ENTER	'\n' 

#define CH_ULCORNER	'+'
#define CH_URCORNER	'+'
#define CH_LLCORNER	'+'
#define CH_LRCORNER	'+'


/* Color defines */
#define COLOR_BLACK  	       	0x00
#define COLOR_WHITE  	       	0x01
#define COLOR_RED    	       	0x02
#define COLOR_CYAN      		0x03
#define COLOR_VIOLET 	       	0x04
#define COLOR_GREEN  	       	0x05
#define COLOR_BLUE   	       	0x06
#define COLOR_YELLOW 	       	0x07
#define COLOR_ORANGE 	       	0x08
#define COLOR_BROWN  	       	0x09
#define COLOR_LIGHTRED       	0x0A
#define COLOR_GRAY1  	       	0x0B
#define COLOR_GRAY2  	       	0x0C
#define COLOR_LIGHTGREEN     	0x0D
#define COLOR_LIGHTBLUE      	0x0E
#define COLOR_GRAY3  	       	0x0F

void conio_init(void);

void clrscr(void);

/* gotoxy same as in GBDK 
#define wherex()  posx()
#define wherey()  posy()
*/

/** Move the cursor to an absolute position.
 */
void gotoxy(UINT8 x, UINT8 y);

unsigned char wherex(void);
unsigned char wherey(void);

void cclear(char c);
void cclearxy(unsigned char x,unsigned char y,char c);

void chline(char c);
void chlinexy(unsigned char x,unsigned char y,char c);
void cvline(char c);
void cvlinexy(unsigned char x,unsigned char y,char c);

void cputc(char c);
void cputcxy(unsigned char x,unsigned char y,char c);

void cputs(char *s);
void cputsxy(unsigned char x,unsigned char y,char *s);

void cprintf(char *format,...);

unsigned char bgcolor(unsigned char col);
unsigned char bordercolor(unsigned char col);
unsigned char textcolor(unsigned char col);
unsigned char revers(unsigned char col);
unsigned char cursor(unsigned char col);
 
void screensize(unsigned char *x,unsigned char *y);

unsigned char kbhit(void);
unsigned char cgetc(void);

unsigned char cpeekchar(void);
unsigned char cpeekcharxy(unsigned char x,unsigned char y);
unsigned char cpeekcol(void);
unsigned char cpeekcolxy(unsigned char x,unsigned char y);

/** Writes out a single character at the current cursor
    position.
    Does not update the cursor or interpret the character.
*/
void
setchar(char c);

/** @file gb/drawing.h
    All Points Addressable (APA) mode drawing library.

    Drawing routines originally by Pascal Felber
    Legendary overhall by Jon Fuge <jonny@q-continuum.demon.co.uk>
    Commenting by Michael Hope

    Note that the standard text printf() and putchar() cannot be used
    in APA mode - use gprintf() and wrtchr() instead.
*/


#endif // __CONIO_H__

 
