
#include <stdlib.h>
#include <stdarg.h>
#include <ctype.h>

#include "gba.h"
#include "conio.h"

#define SCREEN_X	(240/8)
#define SCREEN_Y	(160/8)

//static void blitchar(int chr,int x,int y,int col,int bcol);
 void blitchar(int chr,int x,int y,int col,int bcol);

//static unsigned char  conbitmap[0xa000];
 unsigned char  conbitmap[0xa000];
static unsigned char  conscreen[SCREEN_X][SCREEN_Y];
static   signed char concolor [SCREEN_X][SCREEN_Y];
static   signed char conbcolor[SCREEN_X][SCREEN_Y];
static int curx=0,cury=0;
static int tcol=1,tbgcol=-1,bcol=0,trev=0;

unsigned char CurrBuffNo=0;
unsigned long FrameBuffer[2]={0x06000000,0x0600a000};

void ge_init_screen(void)
{

    DmaClear32(3, 0,   VRAM,     VRAM_SIZE);  /* VRAM Clear      */
    DmaClear32(3, 0,    OAM,      OAM_SIZE);  /* OAM Clear       */
    DmaClear32(3, 0,   PLTT,     PLTT_SIZE);  /* Palette Clear   */
    DmaClear32(3, 0,   0x04000000,     0x60);  /* Video-Regs Clear   */

    *(volatile unsigned short *)REG_BG2CNT =                            /* Set BG 0 control register */
            BG_COLOR_256 | BG_SCREEN_SIZE_0 | BG_PRIORITY_0
            | (1<<13) ;

    *(volatile unsigned short*)REG_DISPCNT = DISP_MODE_4 | DISP_BG2_ON | DISP_OBJ_ON | DISP_OBJ_CHAR_1D_MAP;
    *(volatile unsigned short*)REG_BLDMOD  = BLD_BG0;
    *(volatile unsigned short*)REG_BLDY  = 0x1f;

    /* set affine parameter num 1 to 'not rotated, not scaled' */
    *(volatile unsigned short*)REG_BG2PA=0x0100;   /*  1.0 */
    *(volatile unsigned short*)REG_BG2PB=0x0000;   /*  0.0 */
    *(volatile unsigned short*)REG_BG2PC=0x0000;   /*  0.0 */
    *(volatile unsigned short*)REG_BG2PD=0x0100;   /*  1.0 */

}

void ge_blit_bg(unsigned long *src)
{
unsigned long *dest;
int i;

        dest=(unsigned long*)CurrFrameBuffer;

        for(i=0;i<(SCREEN_Y*8);i++){
            DmaCopy32(3, src, dest, (sizeof(unsigned char))*((SCREEN_X*8)));
            src+=(240>>2); dest+=(240>>2);
        }

}

void ge_flip_bg_buffer(void) {

          *(volatile unsigned short*)REG_DISPCNT = DISP_MODE_4 |
                                DISP_BG2_ON |
                                DISP_OBJ_ON |
                                DISP_OBJ_CHAR_1D_MAP |
                                (CurrBuffNo<<4);

          CurrBuffNo^=1;

}

const unsigned short palette[0x100] = {
	argb1555(0,0x00,0x00,0x00),
	argb1555(0,0xff,0xff,0xff),
	argb1555(0,0x68,0x27,0x2b),
	argb1555(0,0x70,0xa4,0xb2),
	argb1555(0,0x6f,0x3d,0x86),
	argb1555(0,0x58,0x8d,0x43),
	argb1555(0,0x35,0x28,0x79),
	argb1555(0,0xb8,0xc7,0x6f),
	argb1555(0,0x6f,0x4f,0x25),
	argb1555(0,0x43,0x39,0x00),
	argb1555(0,0x9a,0x67,0x59),
	argb1555(0,0x44,0x44,0x44),
	argb1555(0,0x6c,0x6c,0x6c),
	argb1555(0,0x9a,0xd2,0x84),
	argb1555(0,0x6c,0x5e,0xb5),
	argb1555(0,0x95,0x95,0x95)
};

void conio_init(void)
{
    ge_init_screen();
    ge_blit_pal(palette);
	tcol=1;
	bcol=0;
	tbgcol=-1;
	trev=0;
}

void conio_update(void)
{
int x,y;
int ch,co,bo;

		for(x=0;x<SCREEN_X;x++)
		{
			for(y=0;y<SCREEN_Y;y++)
			{

				#if 0
				ch=conscreen[x][y]; // charcode
				bo=conbcolor[x][y]; // bgcolor
				if(! ( (bo==-1) & (!isgraph(ch)) ) ){
					co=concolor[x][y]; // charcolor
					blitchar(ch,x,y,co,bo);
					//blitchar(ch,x,y,0,0xff);
				}
				//blitchar('a'+x,x,y,0,0xff);
				#endif

				if(bcol==-1)	/* transparent bg */
				{
					ch=conscreen[x][y]; // charcode
					if(isgraph(ch))
					{
						co=concolor[x][y]; // charcolor
						blitchar(ch,x,y,co,-1);
					}
				}
				else
				{

				//conbcolor[x][y]=-1;
					bo=conbcolor[x][y]; // bgcolor


					if(bo==-1) bo=bcol; /* common bg color */
					ch=conscreen[x][y]; // charcode
					co=concolor[x][y];  // charcolor

					blitchar(ch,x,y,co,bo);
				}

			}
		}

        ge_blit_bg((unsigned long*)&conbitmap[0]);
        ge_flip_bg_buffer();
}

void clrscr(void)
{
int i;
	// clear screen buffer;
	for(i=0;i<(SCREEN_X*SCREEN_Y);i++){
		((unsigned char*)(&conscreen[0][0]))[i]=' ';
	}
	for(i=0;i<(SCREEN_X*SCREEN_Y);i++){
		((signed short*)(&concolor[0][0]))[i]=tcol;
	}
	for(i=0;i<(SCREEN_X*SCREEN_Y);i++){
		((signed short*)(&conbcolor[0][0]))[i]=tbgcol;
	}
	curx=cury=0;
}

extern const unsigned char _binary_ascchar_raw_start[];
extern const unsigned char _binary_gba_ascchar_raw_start[];

// blit transparent char
//static void blitchar(int chr,int x,int y,int col,int bcol)
 void blitchar(int chr,int x,int y,int col,int bcol)
{
unsigned char *c;
unsigned char *s;
int i,ii;
//int back;

		// offset on screen
//		s=(unsigned char*)gpDrawSurface->ptbuffer;
		s=(unsigned char*)conbitmap;
		//s+=231-(y*8)+(x*240*8);
		s+=((y*(8*SCREEN_X*8))+(x*8));
		// offset in charset
		//chr*=(8*8);
		chr=((chr/32)*(256*8))+((chr%32)*8);

//  		c=(unsigned char*)((((unsigned long)&_binary_gba_ascchar_raw_start[chr])+0));
  		c=(unsigned char*)((((unsigned long)&_binary_ascchar_raw_start[chr])+0));

 // 		c=(unsigned char*)((((unsigned long)&_binary_font8x8_bin_start[chr])+0));
//		c+=(chr*(8*8));

#if 0
			for(i=0;i<8;i++) {
				for(ii=0;ii<8;ii++){
					*s=ii;

					c++;
					s++;
				}
           		s+=((SCREEN_X*8)-8);
           		c+=((256)-8);
		}
		return;
#endif

		if(bcol==-1) { // blit transparent ?

//			if(!isgraph(chr)) return;

			for(i=0;i<8;i++) {
				for(ii=0;ii<8;ii++){
	//				if(*c==0xff) *s=*c;

					if(*c!=0) *s=col;

	//				*s=col;

					c++;
					s++;
				}
           		s+=((SCREEN_X*8)-8);
           		c+=((256)-8);
			}

		} else {	// blit solid

// 			if(tbgcol==-1) back=bcol;
// 			else back=tbgcol;

			for(i=0;i<8;i++) {
				for(ii=0;ii<8;ii++){
	//				if(*c==0xff) *s=*c;
					if(*c!=0) *s=col;
					else *s=bcol;

		//			*s=col;

					c++;
					s++;
				}
           		s+=((SCREEN_X*8)-8);
           		c+=((256)-8);
			}

		}
//		return;
}

static void putchar(int c)
{
/*unsigned char *d;
unsigned char *s;
int x,y,co,bo;*/
//int back;

	switch(c){
		case '\n':
			curx=0;
			cury++;
			break;
		default:
			conscreen[curx][cury]=c;

			//if(tbgcol==-1) back=bcol;
			//else back=tbgcol;

			///back=tbgcol;

			if(trev==0)
			{
				concolor[curx][cury]=tcol;
				conbcolor[curx][cury]=tbgcol;
			}
			else
			{
				concolor[curx][cury]=tbgcol;
				conbcolor[curx][cury]=tcol;
				//conbcolor[curx][cury]=7;//tbgcol;
			}

			curx++;
			break;
	}

	if(curx>SCREEN_X){ // end of line
		curx=0;
		cury++;
	}

	#if 0
	if(cury>29){ // last line

		s=(u8*)gpDrawSurfaces[gpDrawSurfaceIndex].ptbuffer;
		d=s+239;
		s=d-8;
		for(x=0;x<320;x++){
			for(y=0;y<(239-8);y++){
				d[y]=s[y];
			}
			s+=240;
			d+=240;
		}

		// scroll up one line
		cury=29;
		for(x=0;x<40;x++){
			for(y=0;y<29;y++){
				bo=conbcolor[x][y+1];
				conbcolor[x][y]=bo;
				co=concolor[x][y+1];
				concolor[x][y]=co;
				c=conscreen[x][y+1];
				conscreen[x][y]=c;
				blitchar(c,x,y,co,bo);
//				blitchar2(c,x,y);
			}
		}
		for(x=0;x<40;x++){
			conscreen[x][y]=' ';
			concolor[x][y]=tcol;
			conbcolor[x][y]=bcol;
			blitchar(' ',x,y,tcol,bcol);
//			blitchar2(' ',x,y);
		}
	}
	#endif // noscroll
}


void gotoxy(int x,int y){
	curx=x;cury=y;
}
int wherex(void){
	return(curx);
}
int wherey(void){
	return(cury);
}

unsigned char cpeekchar(void)
{
	return conscreen[curx][cury];
}
unsigned char cpeekcol(void)
{
	return concolor[curx][cury];
}
unsigned char cpeekcharxy(unsigned char x,unsigned char y)
{
	gotoxy(x,y);
	return cpeekchar();
}
unsigned char cpeekcolxy(unsigned char x,unsigned char y)
{
	gotoxy(x,y);
	return cpeekcol();
}

void cputc(const char c)
{
	putchar(c);
//	UpdateConio();
}

void cputs(const char *s){
	while(*s!=0){
		putchar(*s);s++;
	}
//	UpdateConio();
}

void cvline (int length)
{
	int x=wherex();
	int y=wherey();
	while(length--)
	{
		gotoxy(x,y);
		putchar(CH_VLINE);
		y++;
	}
}

void chline (int length){
	while(length--) putchar(CH_HLINE);
}
void cclear (int length){
			while(length--) cputc(' ');
}


void chlinexy(unsigned char x,unsigned char y,char c)
{
	gotoxy(x,y);
	chline(c);
}
void cvlinexy(unsigned char x,unsigned char y,char c)
{
	gotoxy(x,y);
	cvline(c);
}
void cputcxy(unsigned char x,unsigned char y,char c)
{
	gotoxy(x,y);
	cputc(c);
}
void cputsxy(unsigned char x,unsigned char y,char *s)
{
	gotoxy(x,y);
	cputs(s);
}
void cclearxy(unsigned char x,unsigned char y,char c)
{
	gotoxy(x,y);
	cclear(c);
}


extern int vsprintf(char *string,const char *format,va_list param);

void cprintf(char *format,...)
{
va_list args;
static char string[0x100];
//char *string;

//        string=(char*)malloc(0x100);

        va_start(args,format);
        vsprintf((char*)string,(char*)format,(va_list)args);
        va_end(args);
		cputs(string);

//        free(string);

}

int textcolor(int col)
{
int c;
	c=tcol;
	tcol=col;
	return(c);
}
int textbackground(int col)
{
int c;
	c=tbgcol;
	tbgcol=col;
	return(c);
}

int bgcolor(int col)
{
int c;
	c=bcol;
	bcol=col;
	return(c);
}

int revers(int col)
{
int c;
	c=trev;
	trev=col;
	return(c);
}

int bordercolor(int col)
{
	col=col;
	return 0;
}

void screensize(unsigned char *x,unsigned char *y)
{
	*x=SCREEN_X;*y=SCREEN_Y;
}
