
extern unsigned char CurrBuffNo;
extern unsigned long FrameBuffer[2];

#include "gba.h"

#define CurrFrameBuffer FrameBuffer[CurrBuffNo]
#define ge_blit_pal(_p) DmaCopy32(3, (_p), 0x05000000, (sizeof(unsigned char))*(0x200));
#define argb1555(_a,_r,_g,_b) ((_a<<15)|((_b>>3)<<10)|((_g>>3)<<5)|(_r>>3))

#define CH_RTEE  '+'
#define CH_LTEE  '+'
#define CH_CROSS '+'
#define CH_ENTER	'\n'

#define CH_ULCORNER	'+'
#define CH_URCORNER	'+'
#define CH_LLCORNER	'+'
#define CH_LRCORNER	'+'

#define CH_HLINE '-'
#define CH_VLINE '!'

#define CH_STOP 	8

#define CH_F1   	0x14
#define CH_F3   	0x15
#define CH_F5   	0x16
#define CH_F7   	0x17

#define CH_CURS_UP		0x01
#define CH_CURS_DOWN	0x02
#define CH_CURS_LEFT	0x03
#define CH_CURS_RIGHT	0x04

#define CH_ESC		8
#define CH_DEL		20


/* Color defines */
#define COLOR_BLACK  	       	0x00
#define COLOR_WHITE  	       	0x01
#define COLOR_RED    	       	0x02
#define COLOR_CYAN      		0x03
#define COLOR_VIOLET 	       	0x04
#define COLOR_GREEN  	       	0x05
#define COLOR_BLUE   	       	0x06
#define COLOR_YELLOW 	       	0x07
#define COLOR_ORANGE 	       	0x08
#define COLOR_BROWN  	       	0x09
#define COLOR_LIGHTRED       	0x0A
#define COLOR_GRAY1  	       	0x0B
#define COLOR_GRAY2  	       	0x0C
#define COLOR_LIGHTGREEN     	0x0D
#define COLOR_LIGHTBLUE      	0x0E
#define COLOR_GRAY3  	       	0x0F

void conio_init(void);
void conio_update(void);

int revers(int col);
int bgcolor(int col);
int textbackground(int col);
int textcolor(int col);

void clrscr(void);
void gotoxy(int x,int y);
int wherex(void);
int wherey(void);

void cclear(int c);
void cclearxy(unsigned char x,unsigned char y,char c);

void chline(int c);
void chlinexy(unsigned char x,unsigned char y,char c);
void cvline(int c);
void cvlinexy(unsigned char x,unsigned char y,char c);

void cputc(const char c);
void cputcxy(unsigned char x,unsigned char y,char c);

void cputs(const char *s);
void cputsxy(unsigned char x,unsigned char y,char *s);

void cprintf(char *format,...);

unsigned char cpeekchar(void);
unsigned char cpeekcol(void);
unsigned char cpeekcharxy(unsigned char x,unsigned char y);
unsigned char cpeekcolxy(unsigned char x,unsigned char y);



 
