
#ifndef __CONIO_H__
#define __CONIO_H__

#ifdef __cplusplus
extern "C" {
#endif

#include "gp32/syscall.h"
#include "gp32/graphics.h"
#include "gp32/gptypes.h"

//#include <string.h>
#include <stdarg.h>                       /* for the va-macro family */


#define CH_RTEE  '+'
#define CH_LTEE  '+'
#define CH_CROSS '+'
#define CH_ENTER	'\n'

#define CH_ULCORNER	'+'
#define CH_URCORNER	'+'
#define CH_LLCORNER	'+'
#define CH_LRCORNER	'+'

#define CH_STOP 	8

#define CH_F1   	0x14
#define CH_F3   	0x15
#define CH_F5   	0x16
#define CH_F7   	0x17

#define CH_CURS_UP		0x01
#define CH_CURS_DOWN	0x02
#define CH_CURS_LEFT	0x03
#define CH_CURS_RIGHT	0x04

#define CH_ESC		8
#define CH_DEL		20

#define CH_HLINE '-'
#define CH_VLINE '!'

/* Color defines */
#define COLOR_BLACK  	       	0x00
#define COLOR_WHITE  	       	0x01
#define COLOR_RED    	       	0x02
#define COLOR_CYAN      		0x03
#define COLOR_VIOLET 	       	0x04
#define COLOR_GREEN  	       	0x05
#define COLOR_BLUE   	       	0x06
#define COLOR_YELLOW 	       	0x07
#define COLOR_ORANGE 	       	0x08
#define COLOR_BROWN  	       	0x09
#define COLOR_LIGHTRED       	0x0A
#define COLOR_GRAY1  	       	0x0B
#define COLOR_GRAY2  	       	0x0C
#define COLOR_LIGHTGREEN     	0x0D
#define COLOR_LIGHTBLUE      	0x0E
#define COLOR_GRAY3  	       	0x0F


void conio_init(void);
void conio_update(void);

void cputc(const char c);
void cputs(const char *s);
void cprintf(char *format,...);
void gotoxy(int x,int y);
void gotox(int x);
void gotoy(int y);
int wherex(void);
int wherey(void);
void clrscr(void);
int textcolor(int col);
int bgcolor(int col);
void chline (int length);
void cclear (int length);

//#define cgetc() GpKeyGet()


extern GPDRAWSURFACE gpDrawSurfaces[2];//={{0},{0}};
extern int gpDrawSurfaceIndex;//=0;

#if 0
void cmsgbox(char *text);
typedef struct tagCLISTITEM {
	int 		  tag;
	struct tagCLISTITEM *next; 	// ptr to next listitem
	char		 *text;
	int			 numopt;		// number of options
	int			 valopt;		// current option value
//	void         *item;     	// ptr to main text
	char		 **opt;      	// ptr to text for options
	struct tagCLIST *sublist;
} CLISTITEM;

typedef struct tagCLIST {
	int 	   items;
	CLISTITEM *first;
	char	  *top;
	char	  *bottom;
	int		  x,y,w,h;
	int		   soffs,ioffs;
} CLIST;


int clistbox(CLIST *list);
#endif

#ifdef __cplusplus
}	// extern "C"
#endif

#endif


