
#ifndef _CTYPE_H_
#define _CTYPE_H_

/*
int isascii( int c )    - nonzero if in range 0-127
int isalpha( int c )    - nonzero if letter
int isdigit( int c )    - nonzero if digit
int isxdigit( int c )   - nonzero if hexadecimal digit
int islower( int c )    - nonzero if lowercase
int isupper( int c )    - nonzero if uppercase
int isprint( int c )    - nonzero if printable 0x20-0x7E
int isspace( int c )    - nonzero if space,tab, CR, LF, VT or FF

int isalnum( int c )    - nonzero if letter or digit
int iscntrl( int c )    - nonzero if 0x7F, or 0x00-0x1F
int isgraph( int c )    - nonzero if printable 0x21-0x7E excl space
int ispunct( int c )    - nonzero if punct char (iscntrl | isspace)
*/

#define __isascii  0x01
#define __isalpha  0x02
#define __isdigit  0x04
#define __isxdigit 0x08
#define __islower  0x10
#define __isupper  0x20
#define __isprint  0x40
#define __isspace  0x80

#define __isalnum  __isalpha|__isdigit

#ifndef _CTYPE_C_
extern unsigned char __is[0x100];
#endif

#define _isascii(_c)    (__is[(_c)]&(__isascii))
#define _isalpha(_c)    (__is[(_c)]&(__isalpha))
#define _isdigit(_c)    (__is[(_c)]&(__isdigit))
#define _isxdigit(_c)   (__is[(_c)]&(__isxdigit))
#define _islower(_c)    (__is[(_c)]&(__islower))
#define _isupper(_c)    (__is[(_c)]&(__isupper))
#define _isprint(_c)    (__is[(_c)]&(__isprint))
#define _isspace(_c)    (__is[(_c)]&(__isspace))

#define _isalnum(_c)    (__is[(_c)]&(__isalnum))
#define _iscntrl(_c)    (_isprint(_c)^__isprint)
#define _ispunct(_c)    (_iscntrl(_c))||(_isspace(_c))
#define _isgraph(_c)    ((_isprint(_c))&&(_isspace(_c)^__isspace))

#endif // ctype.h
