
#include <joystick.h>
#include <time.h>

#ifdef __NES__
#include "nes.h"

#elif defined(__PCENGINE__)
#include "pcengine.h"

#elif defined(__GAMEBOY__)
#include "gb.h"

#elif defined(__GP32__)
#include "gp32.h"
#define __fastcall__

#elif defined(__GBA__)
#include "gba.h"
#include "conio.h"
#define __fastcall__

#else
#include <conio.h>
#endif

static unsigned char _lastkey=0;
static clock_t _chardelay=0;
static unsigned char rptkey=0;

static void _getkey(void)
{
unsigned char j,key;

	if(_lastkey==0)
	{
	    #if defined(OLDJOYSTICKAPI)
		// use old readjoy api
		j=readjoy(0);
		#else
		// use new joystick driver api
	    j=joy_read(0);
		#endif
		key=0;

	    #if defined(OLDJOYSTICKAPI)

		if (j & joy_masks[JOY_FIRE]) key=CH_ENTER;
	    else if (j & joy_masks[JOY_UP]) key=CH_CURS_UP;
	    else if (j & joy_masks[JOY_LEFT]) key=CH_CURS_LEFT;
	    else if (j & joy_masks[JOY_RIGHT]) key=CH_CURS_RIGHT;
	    else if (j & joy_masks[JOY_DOWN]) key=CH_CURS_DOWN;
	    else if (j & joy_masks[JOY_FIRE_B]) key=CH_STOP;
	    else if (j & joy_masks[JOY_START]) key=CH_F1;
	    else if (j & joy_masks[JOY_SELECT]) key=CH_F3;

		#else

       	if (j & joy_masks[JOY_FIRE]) key=CH_ENTER;
//       	if (j & joy_masks[JOY_FIRE]) key=CH_F5;
	    else if (j & joy_masks[JOY_UP]) key=CH_CURS_UP;
	    else if (j & joy_masks[JOY_LEFT]) key=CH_CURS_LEFT;
	    else if (j & joy_masks[JOY_RIGHT]) key=CH_CURS_RIGHT;
	    else if (j & joy_masks[JOY_DOWN]) key=CH_CURS_DOWN;

        // esc==f1 menukey
	    else if (j & joy_masks[JOY_SELECT]) key=CH_F1;

        // stop==f3 windowswitchkey
//	    else if (j & joy_masks[JOY_FIRE_B]) key=CH_STOP;
	    else if (j & joy_masks[JOY_FIRE_B]) key=CH_F3;

	    else if (j & joy_masks[JOY_START]) key=CH_F5;

		#endif

		//if(key!=0) _lastkey=key;
		//return;

		#if 1
		/* kbd repeat */
		if(key!=0)
		{
			if(key==rptkey)
			{
				/* delay keypress */
				if(_chardelay>clock())
				{
					return;
				}
			}
			rptkey=key;
			_chardelay=clock()+(CLOCKS_PER_SEC/8);
			_lastkey=key;
		}
		#endif

	}
}

#ifndef kbhit
unsigned char __fastcall__ kbhit(void)
{
	_getkey();

	if(_lastkey==0)
	{
		return(0);
	}
	else
	{
		return(1);
	}

}
#endif

#ifndef cgetc
unsigned char __fastcall__ cgetc(void)
{

unsigned char k;

	/* wait for key */
	while(_lastkey==0)
	{
		_getkey();
	}
	k=_lastkey; // get last key
    _lastkey=0;
    return k;

}
#endif


