;;	.include	"global.inc"
STACK = 0xcfff

	;; ****************************************
	;; Beginning of module
	;; BANKED: checked
	.title	"Runtime"
	.module	Runtime

    .area	_HEADER (ABS)
    .globl _start
	.org	32768
_start:
    jp code_start

;;	.area	_HOME

	.area	_CODE

	;; ****************************************
    .globl code_start
code_start:
	;; Beginning of the code
	DI			; Disable interrupts
	XOR	A
	;; Initialize the stack
	LD	HL,#code_start
	LD	SP,#STACK
	;; Clear from 0xC000 to 0xDFFF
;	LD	HL,#0xDFFF
;	LD	C,#0x20
;	LD	B,#0x00
;1$:
;	LD	(HL),A
;    dec hl
;	DEC	B
;	JR	NZ,1$
;	DEC	C
;	JR	NZ,1$
	;; Clear from 0xFE00 to 0xFEFF

    ;; Store CPU type

	;; Turn the screen off

	;; Initialize the display

	;; Copy refresh_OAM routine to HIRAM

	;; Install interrupt routines

	;; Standard color palettes

	;; Turn the screen on

	XOR	A		; Erase the malloc list
;	LD	(_malloc_heap_start+0),A
;	LD	(_malloc_heap_start+1),A
;	LD	(.sys_time+0),A	; Zero the system clock
;	LD	(.sys_time+1),A

;;	call	gsinit

;	CALL	.init

	EI			; Enable interrupts

	;; Call the main function
	;;CALL	banked_call
	call _main

_exit::
99$:
	HALT
	JR	99$		; Wait forever


	;; ****************************************

	;; Ordering of segments for the linker
	;; Code that really needs to be in bank 0
    .area _HEADER
;	.area	_HOME
	;; Similar to _HOME
;	.area	_BASE
	;; Code
	.area	_CODE
	;; Constant data
	.area	_LIT
	;; Constant data used to init _DATA
	.area	_GSINIT
	.area	_GSINITTAIL
	.area	_GSFINAL
	;; Constant data area that can be used for post-gsinit setup.
	.area	_CLINIT
	.area	_CLFINAL
	;; Initialised in ram data
	.area	_DATA
	;; Uninitialised ram data
	.area	_BSS
	;; For malloc
	.area	_HEAP

	.area	_BSS

	;; Runtime library
	.area	_GSINIT
gsinit::
	.area	_GSINITTAIL
	ret

	.area	_HOME

	.area	_HEAP
_malloc_heap_start::

;	.include "sfr.inc"
