;
; Ullrich von Bassewitz, 2002-12-03
;
; unsigned char __fastcall__ get_tv (void);
; /* Return the video mode the machine is using */
;

        .export         _get_tv

    	.include	"vic20/vic20.inc"
		.constructor	detectpalntsc,32	; other stuff may depend on this!


;--------------------------------------------------------------------------
; _get_tv

.proc   _get_tv

        lda     PALFLAG
        ldx     #0
        rts

.endproc

detectpalntsc:

	; detect pal/ntsc
	; pal has 312, ntsc 262/263 lines

	sei

	; preload x with 264
    ldx #(266)>>1

	; wait for line #0
	lda #0
@s1:
	cmp VIC+4
	bne @s1

	; wait until after line #266
@s3:
	lda VIC+4
@s2:
	cmp VIC+4
	beq @s2
    dex
	bne @s3

	; if PAL, line is > 264

	lda VIC+4
	cmp #264>>1
	bcc @ntsc
	inx
@ntsc:
	stx PALFLAG

	cli
	rts
