;
; Ullrich von Bassewitz, 06.08.1998
;
; Low level stuff for screen output/console input
;
; added support for non-standard (larger) screensize - Groepaz/Hitmen, 07.12.2002
; thx to Fungus for verifying the hacked values on a real vic20
;

	.exportzp	CURS_X, CURS_Y
	.export		COLRAM_PAGE

	.constructor initconio
	.destructor  deinitconio

	.include	"vic20/vic20.inc"
	.include	"vic20/hard26/hard26.inc"

initconio:

	; find out about colorram-bank so the fixes
	; work with expanded and unexpanded vic
	; (kernal doesnt set any value like for videoram)

	lda VIC+2
	and #$80
	bne l3
	lda #$94	; std for expanded
	.byte $2c   ; bit absolute
l3:
	lda #$96	; std for unexpanded
	sta COLRAM_PAGE

	; set screen columns
	lda VIC+2
	and #$80
	ora #charsperline
	sta VIC+2

	; set screen rows
	lda #screenrows*2
	sta VIC+3

	lda PALFLAG
	beq @ntsc

	; center screen
	ldx #screenxoffs_pal
	lda #screenyoffs_pal
	bne @pl	; jump always

@ntsc:
	ldx #screenxoffs_ntsc
	lda #screenyoffs_ntsc
@pl:
	stx VIC+0
	sta VIC+1
	rts

deinitconio:

	; set screen columns
	lda VIC+2
	and #$80
	ora #charsperline_std
	sta VIC+2

	; set screen rows
	lda #screenrows_std*2
	sta VIC+3

	lda PALFLAG
	beq @ntsc

	; center screen
	ldx #screenxoffs_std_pal
	ldy #screenyoffs_std_pal
	bne @pl	; jump always
@ntsc:
	ldx #screenxoffs_std_ntsc
	ldy #screenyoffs_std_ntsc
@pl:
	stx VIC+0
	sty VIC+1

	rts

	 .bss
COLRAM_PAGE:	.res	1
