;
; Ullrich von Bassewitz, 06.08.1998
;
; Low level stuff for screen output/console input
;

	.exportzp	CURS_X, CURS_Y

	.constructor initsoft40
	.destructor  deinitsoft40

	.include	"vic20/vic20.inc"
	.include	"vic20/soft40/soft40.inc"

    .importzp tmp1
	.import __textcolor
	.import PLOT

initsoft40:

	lda #>soft40_screen
	sta SCREEN_PTR+1
	lda #<soft40_screen
    sta SCREEN_PTR

	ldy #0
	sty tmp1

l5:

	tya
	pha
    ldy #$00

	ldx #$00
l4:
	lda tmp1
    sta (SCREEN_PTR),y
	inc tmp1

	lda SCREEN_PTR
	clc
	adc #<(20)
	sta SCREEN_PTR
	lda SCREEN_PTR+1
	adc #>(20)
	sta SCREEN_PTR+1

	inx
	cpx #(screenrows/2)
	bne l4

	lda SCREEN_PTR
	sec
	sbc #<((20*(screenrows/2))-1)
	sta SCREEN_PTR
	lda SCREEN_PTR+1
	sbc #>((20*(screenrows/2))-1)
	sta SCREEN_PTR+1

	pla
	tay

	iny
	cpy #20
	bne l5

	; set screen columns
	lda VIC+2
	and #$80
	ora # 20
	sta VIC+2

	; set screen rows
	lda #((screenrows/2)*2) | 1
	sta VIC+3

	lda PALFLAG
	beq @ntsc

	; center screen
	ldx #screenxoffs_pal
	lda #screenyoffs_pal
	bne @pl	; jump always

@ntsc:
	ldx #screenxoffs_ntsc
	lda #screenyoffs_ntsc
@pl:
	stx VIC+0
	sta VIC+1

	lda #1
	sta __textcolor

	ldx #$00
lp3:
	.repeat $2,page
	sta soft40_colram+(page*$100),x
	.endrepeat
	inx
	bne lp3

	; set cursor to home position
	txa
	tay
	clc
	jsr PLOT

	lda # ((8|5)*16) | 9
	sta VIC+5

	; reverse mode
	lda	VIC_COLOR	; get old value
	and #$f7
	sta	VIC_COLOR	; set new value

	; disable the kernal cursor
	lda #1
	sta CURS_FLAG
	rts

deinitsoft40:
	rts


