;
; Ullrich von Bassewitz, 06.08.1998
;
; void cputcxy (unsigned char x, unsigned char y, char c);
; void cputc (char c);
;

   	.export	       	_cputcxy, _cputc, cputdirect, putchar
	.export		newline, plot
	.import		popa, _gotoxy
	.import		xsize
    .import         PLOT
    .macpack    longbranch

	.import __bgcolor,__textcolor

	.include	"vic20/soft40/soft40.inc"
	.include	"vic20/vic20.inc"

_cputcxy:
		pha	    		; Save C
		jsr	popa		; Get Y
		jsr	_gotoxy		; Set cursor, drop x
		pla			; Restore C

; Plot a character - also used as internal function

_cputc: cmp    	#$0A  		; CR?
    	bne	L1

    	lda	#0
    	sta	CURS_X

		; Set cursor position, calculate RAM pointers
plot:
		ldy CURS_X
		ldx	CURS_Y
		clc
		jmp	PLOT		; Set the new cursor

L1: 	cmp	#$0D  	  	; LF?
       	beq	newline		; Recalculate pointers

		; Printable char of some sort

		tay
		bpl L10

        clc
		adc #$20
		and	#$7F
L10:

cputdirect:
  		jsr	putchar		; Write the character to the screen

; Advance cursor position

advance:
		iny
		cpy	#charsperline
		beq	L3

		sty	CURS_X
		tya
		and #$01
        bne advback

		lda #(screenrows*8)

advptr:
        clc
		adc	SCREEN_PTR
		sta	SCREEN_PTR
        bcc @l1
		inc	SCREEN_PTR+1
@l1:

advback:
		rts

newline:
		inc	CURS_Y
		lda #8
   		bne advptr	; jump always

L3:
		inc	CURS_Y		; new line
		ldx	CURS_Y
		ldy	#0    	  	; + cr
		sty	CURS_X
		clc
		jmp PLOT

; Write one character to the screen without doing anything else
; in:		 A:  character
; returns:	 Y:  cursor X position
; this function is going to be used a lot so we unroll it a bit for speed

; output space

_space:
		lda RVS
		bne _spaceinvers

 		ldy #$00

		lda CURS_X
		and #$01
		bne @l1

    	.repeat 8,line
		lda (SCREEN_PTR),y
		ora #$f0
		sta (SCREEN_PTR),y
		.if (line < 7)
    	iny
		.endif
		.endrepeat
		jmp _back
@l1:
    	.repeat 8,line
		lda (SCREEN_PTR),y
		ora #$0f
		sta (SCREEN_PTR),y
		.if line < 7
    	iny
		.endif
		.endrepeat
@l2:
		jmp _back

; output inverted space

_spaceinvers:

 		ldy #0

		lda CURS_X
		and #$01
		bne @l1

		.repeat 8,line
		lda (SCREEN_PTR),y
		and #$0f
		sta (SCREEN_PTR),y
		.if line < 7
    	iny
		.endif
		.endrepeat
		jmp _back
@l1:
    	.repeat 8,line
		lda (SCREEN_PTR),y
		and #$f0
		sta (SCREEN_PTR),y
		.if line < 7
    	iny
		.endif
		.endrepeat

        jmp _back

; output a character

putchar:

 		cmp	#' '    ; space is a special (optimized) case
 		jeq _space

; output character
char:
		ldy #$00
        tax

		lda RVS
		jne _invers

		lda CURS_X
		and #$01
		bne @l1

    	.repeat 8,line
		lda (SCREEN_PTR),y
		and #$0f
		ora soft40_hi_charset+(line*$80),x
		sta (SCREEN_PTR),y
		.if line < 7
    	iny
		.endif
		.endrepeat
		jmp @l2
@l1:

    	.repeat 8,line
		lda (SCREEN_PTR),y
		and #$f0
		ora soft40_lo_charset+(line*$80),x
		sta (SCREEN_PTR),y
		.if line < 7
    	iny
		.endif
		.endrepeat

@l2:

_back:
		ldy CURS_X
		rts

; output inverted character
_invers:

		lda CURS_X
		and #$01
		bne @l1

    	.repeat 8,line
		lda (SCREEN_PTR),y
		ora #$f0
		eor soft40_hi_charset+(line*$80),x
		sta (SCREEN_PTR),y
		.if line < 7
    	iny
		.endif
		.endrepeat
		jmp _back
@l1:
    	.repeat 8,line
		lda (SCREEN_PTR),y
		ora #$0f
		eor soft40_lo_charset+(line*$80),x
		sta (SCREEN_PTR),y
		.if line < 7
    	iny
		.endif
		.endrepeat
        jmp _back


		.export soft40_hi_charset
		.export soft40_lo_charset
		.include "vic20/soft40/charset.s"
