
#
# vic20 max expension memory layout
#

# When additional memory is added to block 1 (and 2 and 3),
# the Memory-Layout is like this:
#
# 0000-03ff                  System Area
# 0400-0fff				     (3k) Exp-Mem Block 0

# 1000-11FF    4096-4607     Screen memory
# 1200-130F                  extended Screen memory
# 1200-...     4608-... 	 User Basic area

# 2000-3fff				     (8k) Exp-Mem Block 1
# 4000-5fff				     (8k) Exp-Mem Block 2
# 6000-7fff				     (8k) Exp-Mem Block 3
#
# 8000-8FFF    32768-36863   4K Character generator ROM

# 9000-93FF    36864-37887   I/O BLOCK 0

# 9400-95FF    37888-38399   Color RAM \
# 9600-97FF                  Color RAM / (1k)

# a000-bfff				     (8k) Exp-Mem Block 4

# C000-DFFF                  Basic ROM
# E000-FFFF                  Basic ROM

MEMORY {
    ZP: start = $02, size = $1A, type = rw, define = yes;
    BASRAM: start = $11ff, size = $0111, define = yes, file = %O, fill=yes;
	# 28159 bytes free $1200-$8000 (27k)
    RAM: start = $1310, size = $6cf0, define = yes, file = %O;
}
SEGMENTS {
    STARTUP: load = BASRAM , type = wprot;
    LOWCODE: load = RAM, type = wprot;
    CODE: load = RAM, type = wprot;
    RODATA: load = RAM, type = wprot;
    DATA: load = RAM, type = rw;
    BSS: load = RAM, type = bss, define = yes;
    ZEROPAGE: load = ZP, type = zp;
}
FEATURES {
    CONDES: segment = RODATA,
	    type = constructor,
	    label = __CONSTRUCTOR_TABLE__,
	    count = __CONSTRUCTOR_COUNT__;
    CONDES: segment = RODATA,
	    type = destructor,
	    label = __DESTRUCTOR_TABLE__,
	    count = __DESTRUCTOR_COUNT__;
}
SYMBOLS {
    __STACKSIZE__ = $400;	# 1K stack
}

