
#ifndef __PORTLIB_H__
#define __PORTLIB_H__

#if defined(__PET__)

#include <cbm.h>
#include <pet.h>
#include "pet/pet.h"

#elif defined(__CBM510__)
#  include <cbm.h>
#  include <cbm510.h>
#  include "cbm510/cbm510.h"

#elif defined(__CBM610__)
#  include <cbm.h>
#  include <cbm610.h>
#  include "cbm610/cbm610.h"

#elif defined(__VIC20__)

#include <cbm.h>
#include <vic20.h>
#include "vic20/vic20.h"

#if defined(__VIC20HACKED__)
// with hardware 26x25
#  include "vic20/hard26/hard26.h"
#elif defined(__SOFT40__)
// with software 40x24
#  include "vic20/soft40/soft40.h"
#endif

#elif defined(__C64__)

#include <cbm.h>
#include <c64.h>
#include "c64/c64.h"

#if defined(__SOFT80__)
#include "c64/soft80/soft80.h"
#endif

#elif defined(__C128__)

#include <cbm.h>
#include <c128.h>
#include "c128/c128.h"

#elif defined(__GEOS__)

// shouldnt atleast cbm.h be available for geos?
//#  include <cbm.h>
//#  include <c64.h>
#include <geos.h>
#include "geos/geos.h"

#elif defined(__PLUS4__)
#  include <cbm.h>
#  include <plus4.h>
#  include "plus4/plus4.h"

#elif defined(__C16__)
#  include <cbm.h>
#  include <c16.h>
#  include "plus4/plus4.h"

#elif defined(__ATARI__)

#include <atari.h>
#include "atari/atari.h"

#elif defined(__APPLE2__)

#include <apple2.h>
#include "apple2/apple2.h"

#elif defined(__ATMOS__)
#  include <atmos.h>
#  include "atmos/atmos.h"

#elif defined(__NES__)

#include <nes.h>
#include "nes/nes.h"

#elif defined(__PCENGINE__)
#include "pcengine/pcengine.h"
//#  include <pcengine.h>

#elif defined(__LUNIX__)
#  include <lunix.h>

#elif defined(__BBC__)
#  include <bbc.h>

#elif defined(__OSA65__)
#  include <osa65.h>

#elif defined(__GAMEBOY__)

#include "gb/gb.h"

#elif defined(__SPECTRUM__)

#include "spectrum/spectrum.h"

#elif defined(__GBA__)

#include "gba/gba.h"

#elif defined(__GP32__)

#include "gp32/gp32.h"

#endif

#include "cc_conf.h"

#endif // __PORTLIB_H__
